<?php
class ControllerModuleLatest extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/latest');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('extension/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('latest', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->cache->delete('product');

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');

		$data['entry_name'] = $this->language->get('entry_name');
		$data['entry_limit'] = $this->language->get('entry_limit');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_status'] = $this->language->get('entry_status');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL')
		);

		if (!isset($this->request->get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('module/latest', 'token=' . $this->session->data['token'], 'SSL')
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('module/latest', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL')
			);
		}

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('module/latest', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action'] = $this->url->link('module/latest', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset($this->request->post['limit'])) {
			$data['limit'] = $this->request->post['limit'];
		} elseif (!empty($module_info)) {
			$data['limit'] = $module_info['limit'];
		} else {
			$data['limit'] = 5;
		}

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = 200;
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = 200;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}


				$data['entry_title']    = $this->language->get('entry_title');
				$data['entry_screen']   = $this->language->get('entry_screen');
				$data['entry_columns']  = $this->language->get('entry_columns');
				$data['entry_cssclass'] = $this->language->get('entry_cssclass');

				$data['text_screen_all'] = $this->language->get('text_screen_all');
				$data['text_screen_lg']  = $this->language->get('text_screen_lg');
				$data['text_screen_md']  = $this->language->get('text_screen_md');
				$data['text_screen_sm']  = $this->language->get('text_screen_sm');
				$data['text_screen_except_lg'] = $this->language->get('text_screen_except_lg');
				$data['text_screen_except_md'] = $this->language->get('text_screen_except_md');
				$data['text_screen_except_sm'] = $this->language->get('text_screen_except_sm');
				$data['text_columns_nd'] = $this->language->get('text_columns_nd');

				$data['help_title']    = $this->language->get('help_title');
				$data['help_name']     = $this->language->get('help_name');
				$data['help_screen']   = $this->language->get('help_screen');
				$data['help_columns']  = $this->language->get('help_columns');
				$data['help_cssclass'] = $this->language->get('help_cssclass');
				$data['help_width']    = $this->language->get('help_width');
				$data['help_height']   = $this->language->get('help_height');

				$this->load->model('localisation/language');
				$data['languages'] = $this->model_localisation_language->getLanguages();

				if (isset($this->error['columns'])) {
					$data['error_columns'] = $this->error['columns'];
				} else {
					$data['error_columns'] = '';
				}

				if (isset($this->request->post['title'])) {
					$data['title'] = $this->request->post['title'];
				} elseif (isset($module_info['title']) && !empty($module_info['title'])) {
					$data['title'] = $module_info['title'];
				} else {
					$data['title'] = array();
				}

				if (isset($this->request->post['screen'])) {
					$data['screen'] = $this->request->post['screen'];
				} elseif (isset($module_info['screen']) && !empty($module_info['screen'])) {
					$data['screen'] = $module_info['screen'];
				} else {
					$data['screen'] = '';
				}

				if (isset($this->request->post['columns'])) {
					$data['columns'] = $this->request->post['columns'];
				} elseif (isset($module_info['columns']) && !empty($module_info['columns'])) {
					$data['columns'] = $module_info['columns'];
				} else {
					$data['columns'] = 0;
				}

				if (isset($this->request->post['cssclass'])) {
					$data['cssclass'] = $this->request->post['cssclass'];
				} elseif (isset($module_info['cssclass']) && !empty($module_info['cssclass'])) {
					$data['cssclass'] = $module_info['cssclass'];
				} else {
					$data['cssclass'] = '';
				}
			
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/latest_hdw.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/latest')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}

		if (!$this->request->post['width']) {
			$this->error['width'] = $this->language->get('error_width');
		}

		if (!$this->request->post['height']) {
			$this->error['height'] = $this->language->get('error_height');
		}


				if (!is_numeric($this->request->post['columns']) || $this->request->post['columns'] < 0 || $this->request->post['columns'] > 6) {
					$this->error['columns'] = $this->language->get('error_columns');
				}
			
		return !$this->error;
	}
}